<?php
function listing_location_admin_settings_form() {
  
  //  We check if this is a single country listing
  $result = db_query("SELECT DISTINCT(country) FROM {zipcodes}");
  $c = 0;
  while ($row = db_fetch_object($result)) {
    $c++;
  }
  variable_set('listing_location_countries', $c);
  // We also check if this is a single state province listing.
  $result = db_query("SELECT DISTINCT(state) FROM {zipcodes}");
  $c = 0;
  while ($row = db_fetch_object($result)) {
    $state = $row->state;
    $c++;
  }
  variable_set('listing_location_single_province', $c);
  if ($c == 1) {
    $states = listing_location_get_states();
	
    variable_set('listing_location_default_state', $states[$state]);
	variable_set('listing_location_default_state_code', $state);
	drupal_set_message(t('Default province / state set to !state !code', array('!state' => $states[$state], '!code' => $state)));
  }
  else variable_del('listing_location_default_province');
  // This is a simple check to see that our views are in place
  if (_listing_location_check_views()) variable_set('listing_location_views', 1);
 
  else variable_set('listing_location_views', 0);
  
  if (variable_get('listing_location_countries', 0)) {
    $form['defaults'] = array(
      '#type' => 'fieldset',
	  '#title' => t('Defaults'),
	  '#collapsible' => TRUE,
	  '#collapsed' => TRUE
    );
    $form['defaults']['listing_default_country'] = array(
      '#type'          => 'select',
	  '#options'		 => location_get_iso3166_list(),
      '#title'         => t('Default Country'),
	  '#description'   => t('This is the default country for listings.'),
      '#default_value' => variable_get('listing_default_country', 'nz'),
    );
    $form['defaults']['listing_default_location'] = array(
      '#type'          => 'textfield',
      '#title'         => t('Default Location'),
	  '#description'   => t('In the absence of the geoip module, we need a default location to ensure the search has a starting point.  This should be in the form [city-name]: [state/province code] eg Hastings: HKB.  If this is incorrect the site will fail for new users. Note that this functionality applies only to those countries with the necessary data available in the location module zipcodes table.  If you are using a country which does not have that data then use this module '),
      '#default_value' => variable_get('listing_default_location', 'Hastings: HKB'),
    );
    $form['defaults']['listing_location_target_default_distance'] = array(
      '#type'          => 'textfield',
      '#title'         => t('Default proximity'),
	  '#description'   => t('Enter a value for the default proximity in views proximity filters'),
      '#default_value' => variable_get('listing_location_target_default_distance', 25),
    );
    $form['options'] = array(
      '#type' => 'fieldset',
	  '#title' => t('Search Options'),
	  '#collapsible' => TRUE,
	  '#collapsed' => TRUE
    );
    $form['options']['listing_location_include_zipcode'] = array(
      '#type'          => 'checkbox',
      '#title'         => t('Include Zipcode Search'),
	  '#description'   => t('Some countries make greater use of zipcodes than others.  When we include zipcodes then the user has the option of entering a string or a zipcode number in the search field. Check the zipcode database first to ensure that your country has zipcodes.'),
      '#default_value' => variable_get('listing_location_include_zipcode', 0),
    );
    $form['options']['listing_location_include_map'] = array(
      '#type'          => 'checkbox',
      '#title'         => t('Include Map in Listings'),
	  '#description'   => t('Listings whose content type does not include Locations will not display a map.'),
      '#default_value' => variable_get('listing_location_include_map', 1),
    );
    $ctypes = variable_get('listing_content_types', array());
    if (!empty($ctypes)) {
      $form['options']['listing_location_ctypes'] = array(
        '#type'          => 'select',
	    '#options'		 => variable_get('listing_content_types', array()),
        '#title'         => t('Content Types'),
        '#default_value' => variable_get('listing_location_ctypes', array()),
        '#description'   => t('Listing content types to use for location search.  Note that these content types have to be <a href="/admin/listing/general">selected</a> for listings.'),
	    '#multiple'		 => TRUE
      );
    }
    else {
      $form['listing_location_ctypes'] = array(
        '#type'          => 'markup',
	    '#value'         => l(t('No content types are enabled for the listing module'), 'admin/listing/general'),
	  );
    }
    $form['options']['listing_location_select_search'] = array(
      '#type'          => 'checkbox',
      '#title'         => t('Use select search'),
	  '#description'   => t('The default search is a proximity search using the location database. Check this box to use a city select search.  This is only viable if you reduce the number of cities in your search scope to a number that can be handled by a select form.'),
      '#default_value' => variable_get('listing_location_select_search', 0),
    );
    $form['options']['listing_location_include_terms'] = array(
      '#type'          => 'checkbox',
      '#title'         => t('Include terms select'),
	  '#description'   => t('When this box is ticked then the term select form will appear on the search form.'),
      '#default_value' => variable_get('listing_location_include_terms', 1),
    );
  /*
  $categories = array();
  $vocabs = taxonomy_get_vocabularies();
  foreach ($vocabs as $vocab) {
    $categories[$vocab->vid] = $vocab->name;
  }
  $form['listing_search']['listing_select_search_vocab'] = array(
    '#type'          => 'select',
	'#options' 		 => $categories,
    '#title'         => t('Search Taxonomy'),
	'#description'   => t('The taxonomy to use in conducting location searches.'),
    '#default_value' => variable_get('listing_select_search_vocab', 0),
  );
  */
    $form['map'] = array(
      '#type' => 'fieldset',
	  '#title' => t('Listing Map'),
	  '#collapsible' => TRUE,
	  '#collapsed' => TRUE
    );
    $form['map']['listing_location_map_width'] = array(
      '#type'          => 'textfield',
      '#title'         => t('Map width'),
	  '#description'   => t('The width of the map on the web page in pixels.'),
      '#default_value' => variable_get('listing_location_map_width', 300),
    );
    $form['map']['listing_location_map_height'] = array(
      '#type'          => 'textfield',
      '#title'         => t('Map height'),
	  '#description'   => t('The height of the map on the web page in pixels.'),
      '#default_value' => variable_get('listing_location_map_height', 200),
    );
    $form['map']['listing_location_map_zoom'] = array(
      '#type'          => 'textfield',
      '#title'         => t('Map Zoom'),
	  '#description'   => t('The zoom of the map on the web page in pixels.'),
      '#default_value' => variable_get('listing_location_map_zoom', 6),
    );
    $form['views'] = array(
      '#type' => 'fieldset',
	  '#title' => t('Listing Views'),
	  '#collapsible' => TRUE,
	  '#collapsed' => TRUE
    );
    $form['views']['listing_location_view_per_ctype'] = array(
      '#type'          => 'checkbox',
      '#title'         => t('Custom View per Content Type'),
	  '#description'   => t('Check this box to configure a separate view for each listing content type.  You will need to create the relevant page view displays in either ListingsList or ListingsListbyCity depending on which search type you are using.  The default display or block displays will not be made available.  You will need to submit this form before you will be able to configure them.'),
      '#default_value' => variable_get('listing_location_view_per_ctype', 0),
    );
	if (variable_get('listing_location_view_per_ctype', 0)) {
	  if (variable_get('listing_location_select_search', 0)) $view_name = 'ListingsListbyCity';
	  else $view_name = 'ListingsList';
	  $view = views_get_view($view_name);
	  $options = array();
	  foreach ($view->display as $key => $display) {
	    //drupal_set_message(print_r($key,1));
		
		if (substr($key,0,4) == "page") {
		   $options[$key] = $key;
		}
	  }
	  foreach (variable_get('listing_location_ctypes', array()) as $ctype) {
        $form['views']['listing_location_view_display_'.$ctype] = array(
          '#type'          => 'select',
		  '#options'	   => $options,
          '#title'         => $ctype,
	      '#description'   => t('Select the view display to use for this content type'),
          '#default_value' => variable_get('listing_location_view_display_'.$ctype, ''),
        );
	  }
	}
    $form['featured'] = array(
      '#type' => 'fieldset',
	  '#title' => t('Featured Listing Block'),
	  '#collapsible' => TRUE,
	  '#collapsed' => TRUE
    );
    $form['featured']['listing_location_featured_blocks'] = array(
      '#type'          => 'textfield',
      '#title'         => t('Number of block displays'),
	  '#description'   => t('Enter the number of displays in the FeaturedListings view that you wish to process.  The only displays processed are block displays. Each display is processed one after the other.  If the required number of listings cannot be found in the first display then the second display is processed and so on.'),
      '#default_value' => variable_get('listing_location_featured_blocks', 2),
    );
    $form['defaults']['listing_location_featured_list_limit'] = array(
      '#type'          => 'textfield',
      '#title'         => t('Number of items in targeted listing block'),
	  '#description'   => t('Yet to be implemented'),
      '#default_value' => variable_get('listing_location_featured_list_limit', 3),
    );
    $form['featured']['listing_location_featured_text'] = array(
      '#type'          => 'textfield',
      '#title'         => t('Text'),
	  '#description'   => t('Text to appear on featured listing block. Use !city and !state for city and state/province.'),
      '#default_value' => variable_get('listing_location_featured_text', 'Service Providers near !city, !state'),
    );
    $form['views_check'] = array(
      '#type' => 'markup',
	  '#value' => variable_get('listing_location_views', 0) ? '<div>'.t('Location Search Views are enabled').'</div>' : '<div style="color: red">'.t('Cannot find Location Search Views.  Please check instructions').'</div>',
    );
    switch(variable_get('listing_location_single_province', 0)) {
      case 0:
	    $value = t('There is no province data in the zipcodes table.  Please see instructions for inserting country zipcode data for the location module');
	    break;
      case 1:
	    $value = t('There is only one state / province in the zipcodes table so you may remove the state / province parameter from the url.');
	    break;
      default:
	    $value = t('Multiple state / provinces are available so country parameter will show');
	    break;
    }
    $form['province_check'] = array(
      '#type' => 'markup',
	  '#value' => '<div>'.$value.'</div>',
    );
    if (variable_get('listing_location_single_province', 0)) {
      $form['listing_location_show_province_url'] = array(
        '#type'          => 'checkbox',
        '#title'         => t('Province / state in url.'),
        '#description'   => t('Untick this box if you do not want to show the province / state in the url. Default is on.'),
        '#default_value' => variable_get('listing_location_show_province_url', 1)
      );
  
    }
  }
  switch(variable_get('listing_location_countries', 0)) {
    case 0:
	  $value = t('There is no data in the zipcodes table.  Please see instructions for inserting country zipcode data for the location module');
	  break;
    case 1:
	  $value = t('There is only one country in the zipcodes table so you may remove the country parameter from the url.');
	  break;
    default:
	  $value = t('Multiple countries are available so country parameter will show');
	  break;
  }
  $form['country_check'] = array(
    '#type' => 'markup',
	'#value' => '<div">'.$value.'</div>',
  );
  if (variable_get('listing_location_countries', 0)) {
    $form['listing_location_show_country_url'] = array(
      '#type'          => 'checkbox',
      '#title'         => t('Country in url.'),
      '#description'   => t('Untick this box if you do not want to show the country in the url. Default is on.'),
      '#default_value' => variable_get('listing_location_show_country_url', 1)
    );
  }
  $form['#submit'][] = 'listing_location_admin_settings_submit';
  
  return system_settings_form($form);
}
function listing_location_admin_settings_validate($form, $form_state) {
  $default = explode(":",variable_get('listing_default_location', 'Hastings: HKB'));
  $count = db_result(db_query("SELECT COUNT(*) FROM {zipcodes} WHERE LOWER(city)='%s' AND state='%s'", strtolower($default[0]), strtoupper($state_codes[$default[1]])));
  if (!$count) form_set_error('listing_default_location', t('The default province / state / city combination is not in the zipcodes database.  Either change the default or import the data'));
  if (!is_numeric($form_state['values']['listing_location_featured_blocks'])) form_set_error('listing_location_featured_blocks', 'Number of block displays for Featured listing must be numeric.');
  
}
function listing_location_admin_settings_submit($form, $form_state) {

  cache_clear_all('*', 'cache');
}
function listing_location_admin_filter_explanation() {
  $output = '<p>Filterable content is determined by the contents of the zipcodes table which is created by the location module.  All records in this table are inserted by using the .sql file available in the location module directory database.  Currently only about a half a dozen countries are supported.  You may reduce the available records by filtering by province / state and by city.  It is advisable to filter by province first, otherwise the city select form will be unwieldly because it will include thousands of options.</p';
  return $output;
}
function listing_location_admin_provinces_form() {
  //listing_enable();
  $provinces = array();
  $result = db_query("SELECT DISTINCT(state) FROM zipcodes ORDER BY state");
  while ($row = db_fetch_object($result)) {
    $provinces[$row->state] = $row->state;
  }
  $form['explanation'] = array(
    '#type' 		 => 'markup',
	'#value'		 => t('Use this form if you want to restrict the states / provinces that are available on the search form autocomplete.')
  );
  $form['provinces'] = array(
    '#type'          => 'select',
	'#options'		 => $provinces,
    '#title'         => t('State / Provinces'),
	'#description'   => t('Select the states / provinces you wish to keep'),
    '#multiple'		 => TRUE,
  );
  $form['submit'] = array(
    '#type' => 'submit',
	'#value' => t('Submit')
  );
  return $form;
}
function listing_location_admin_provinces_form_submit($form, $form_state) {
  db_query("DELETE FROM {zipcodes} WHERE state NOT IN ('". implode("','", $form_state['values']['provinces'])."')");
}
function listing_location_admin_cities_form() {
  //listing_enable();
  $cities = array();
  $result = db_query("SELECT DISTINCT(city) FROM zipcodes ORDER BY city");
  while ($row = db_fetch_object($result)) {
    $cities[$row->city] = $row->city;
  }
  $form['explanation'] = array(
    '#type' 		 => 'markup',
	'#value'		 => t('Use this form if you want to restrict the cities that are available on the search form autocomplete.  It is advisable to filter by province / state first.')
  );
  $form['cities'] = array(
    '#type'          => 'select',
	'#options'		 => $cities,
    '#title'         => t('Cities'),
	'#description'   => t('Select the cities you wish to keep'),
    '#multiple'		 => TRUE,
  );
  $form['submit'] = array(
    '#type' => 'submit',
	'#value' => t('Submit')
  );
  return $form;
}
function listing_location_admin_cities_form_submit($form, $form_state) {
  db_query("DELETE FROM {zipcodes} WHERE city NOT IN ('". implode("','", $form_state['values']['cities'])."')");
}